diff --git a/libi3/draw_util.c b/libi3/draw_util.c
index 8df8cd5bc..5f8e37018 100644
--- a/libi3/draw_util.c
+++ b/libi3/draw_util.c
@@ -62,8 +62,17 @@ void draw_util_surface_init(xcb_connection_t *conn, surface_t *surface, xcb_draw
 void draw_util_surface_free(xcb_connection_t *conn, surface_t *surface) {
     xcb_free_gc(conn, surface->gc);
 #ifdef CAIRO_SUPPORT
-    cairo_surface_destroy(surface->surface);
-    cairo_destroy(surface->cr);
+    if (cairo_surface_get_reference_count(surface->surface) == 0) {
+        LOG("Not destroying surface, it already has zero references.\n");
+    } else {
+        cairo_surface_destroy(surface->surface);
+    }
+
+    if (cairo_get_reference_count(surface->cr) == 0) {
+        LOG("Not destroying cairo object, it already has zero references.\n");
+    } else {
+        cairo_destroy(surface->cr);
+    }
 #endif
 }
 
